.\"	$NetBSD: com.4,v 1.13 2007/06/01 11:24:22 jnemeth Exp $
.\"
.\" Copyright (c) 1990, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" the Systems Programming Group of the University of Utah Computer
.\" Science Department.
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)dca.4	5.2 (Berkeley) 3/27/91
.\"
.Dd June 1, 2007
.Dt COM 4
.Os
.Sh NAME
.Nm com
.Nd serial communications interface
.Sh SYNOPSIS
.Cd "com0 at isa? port" \&"IO_COM1\&" irq 4
.Cd "com1 at isa? port" \&"IO_COM2\&" irq 3
.Cd "com* at acpi?"
.Cd "com* at cardbus?"
.Cd "com* at isapnp?"
.Cd "com* at mca? slot ?"
.Cd "com* at mhzc?"
.Cd "com* at ofisa?"
.Cd "com* at pcmcia?"
.Cd "com* at pcmcom?"
.Cd "com* at pnpbios? index ?"
.Cd "com* at puc? port ?"
.Cd "com* at xirc?"
.Cd options COM_HAYESP
.Cd options RND_COM
.Ss Arm32
.Cd "com0 at mainbus? base 0x00210fe0"
.Cd "com1 at mainbus? base 0x00210be0"
.Ss HP 9000/300 and 400 Series
.Cd "com* at dio? scode ?"
.Cd "com* at frodo? offset ?"
.Ss IBM PowerPC 4xx
.Cd "com* at opb?"
.Ss SPARC
.Cd "com* at ebus?"
.Cd "com* at obio0"
.Sh DESCRIPTION
The
.Nm
driver provides support for NS8250-, NS16450-, and NS16550-based
.Tn EIA
.Tn RS-232C
.Pf ( Tn CCITT
.Tn V.28 )
communications interfaces.
The NS8250 and NS16450 have single character
buffers, and the NS16550 has a 16 character buffer.
.Pp
Input and output for each line may set to one of following baud rates;
50, 75, 110, 134.5, 150, 300, 600, 1200, 1800, 2400, 4800, 9600,
19200, 38400, 57600, or 115200, or any other baud rate which is a factor
of 115200.
.Pp
The ttyXX devices are traditional dial-in devices; the dtyXX devices are
used for dial-out.
(See
.Xr tty 4 . )
.Pp
.Cd options COM_HAYESP
adds support for the Hayes ESP serial board.
.Pp
With
.Cd options RND_COM
enabled, the
.Nm
driver can be used to collect entropy for the
.Xr rnd 4
entropy pool.
The entropy is generated from interrupt randomness.
.Ss Arm32 specific
If
.Dq flags 1
is specified, the
.Nm
driver will not set the
.Dv MCR_IENABLE
bit on the UART.
This is mainly for use on AST multiport boards, where the
.Dv MCR_IENABLE
bit is used to control whether or not the devices use a shared
interrupt.
.Sh FILES
.Bl -tag -width Pa -compact
.It Pa /dev/dty00
.It Pa /dev/dty01
.It Pa /dev/dty02
.It Pa /dev/tty00
.It Pa /dev/tty01
.It Pa /dev/tty02
.El
.Sh DIAGNOSTICS
.Bl -diag
.It com%d: %d silo overflows
The input
.Dq silo
has overflowed and incoming data has been lost.
.It com%d: weird interrupt: iir=%x
The device has generated an unexpected interrupt
with the code listed.
.El
.Sh SEE ALSO
.Xr acpi 4 ,
.Xr ast 4 ,
.Xr cardbus 4 ,
.Xr isa 4 ,
.Xr isapnp 4 ,
.Xr mca 4 ,
.Xr mhzc 4 ,
.Xr ofisa 4 ,
.Xr pcmcia 4 ,
.Xr pcmcom 4 ,
.Xr pnpbios 4 ,
.Xr puc 4 ,
.Xr rtfps 4 ,
.Xr tty 4 ,
.Xr xirc 4
.Sh HISTORY
The
.Nm
driver was originally derived from the HP9000/300
.Ic dca
driver.
.Sh BUGS
Data loss is possible on busy systems with unbuffered UARTs at high speed.
.Pp
The name of this driver and the constants which define the locations
of the various serial ports are holdovers from
.Tn DOS .
